---
title: FormDataEvent
slug: Web/API/FormDataEvent
tags:
  - API
  - Experimental
  - FormDataEvent
  - Forms
  - Landing
  - Reference
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>FormDataEvent</code></strong> interface represents a <a href="/en-US/docs/Web/API/HTMLFormElement/formdata_event"><code>formdata</code> event</a> — such an event is fired on an {{domxref("HTMLFormElement")}} object after the entry list representing the form's data is constructed. This happens when the form is submitted, but can also be triggered by the invocation of a {{domxref("FormData.FormData", "FormData()")}} constructor.</p>

<p>This allows a {{domxref("FormData")}} object to be quickly obtained in response to a <code>formdata</code> event firing, rather than needing to put it together yourself when you wish to submit form data via a method like {{domxref("XMLHttpRequest")}} (see <a href="/en-US/docs/Web/API/FormData/Using_FormData_Objects">Using FormData objects</a>).</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("FormDataEvent.FormDataEvent","FormDataEvent()")}}</dt>
 <dd>Creates a new <code>FormDataEvent</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent interface, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("FormDataEvent.formData")}}</dt>
 <dd>Contains the {{domxref("FormData")}} object representing the data contained in the form when the event was fired.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// grab reference to form

const formElem = document.querySelector('form');

// submit handler

formElem.addEventListener('submit', (e) =&gt; {
  // on form submission, prevent default
  e.preventDefault();

  // construct a FormData object, which fires the formdata event
  new FormData(formElem);
});

// formdata handler to retrieve data

formElem.addEventListener('formdata', (e) =&gt; {
  console.log('formdata fired');

  // Get the form data from the event object
  let data = e.formData;
  for (var value of data.values()) {
    console.log(value);
  }

  // submit the data via XHR
  var request = new XMLHttpRequest();
  request.open("POST", "/formHandler");
  request.send(data);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG','form-control-infrastructure.html#the-formdataevent-interface', 'FormDataEvent')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FormDataEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("XMLHTTPRequest")}}</li>
 <li>{{domxref("FormData")}}</li>
 <li><a href="/en-US/docs/Web/API/FormData/Using_FormData_Objects">Using FormData objects</a></li>
 <li>{{HTMLElement("Form")}}</li>
</ul>
